# Enum Watcher.Event.KeeperState

java.lang.Object
java.lang.Enum<Watcher.Event.KeeperState>
org.apache.zookeeper.Watcher.Event.KeeperState

All Implemented Interfaces:
  `Serializable, Comparable<Watcher.Event.KeeperState>`

Enclosing interface:
  `Watcher.Event`

@Public public static enum Watcher.Event.KeeperState extends Enum<Watcher.Event.KeeperState>
Enumeration of states the ZooKeeper may be at the event

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`AuthFailed`
Auth failed state
`Closed`
The client has been closed.
`ConnectedReadOnly`
The client is connected to a read-only server, that is the server which is not currently connected to the majority.
`Disconnected`
The client is in the disconnected state - it is not connected to any server in the ensemble.
`Expired`
The serving cluster has expired this session.
`NoSyncConnected`
Deprecated.
`SaslAuthenticated`
SaslAuthenticated: used to notify clients that they are SASL-authenticated, so that they can perform Zookeeper actions with their SASL-authorized permissions.
`SyncConnected`
The client is in the connected state - it is connected to a server in the ensemble (one of the servers specified in the host connection parameter during ZooKeeper client creation).
`Unknown`
Deprecated.

## Method Summary

Modifier and Type
Method
Description
`static Watcher.Event.KeeperState`
`fromInt(int intValue)`
`int`
`getIntValue()`
`static Watcher.Event.KeeperState`
`valueOf(String name)`
Returns the enum constant of this type with the specified name.
`static Watcher.Event.KeeperState[]`
`values()`
Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### Unknown

@Deprecated public static final Watcher.Event.KeeperState Unknown
Deprecated.
Unused, this state is never generated by the server

### Disconnected

public static final Watcher.Event.KeeperState Disconnected
The client is in the disconnected state - it is not connected to any server in the ensemble.

### NoSyncConnected

@Deprecated public static final Watcher.Event.KeeperState NoSyncConnected
Deprecated.
Unused, this state is never generated by the server

### SyncConnected

public static final Watcher.Event.KeeperState SyncConnected
The client is in the connected state - it is connected to a server in the ensemble (one of the servers specified in the host connection parameter during ZooKeeper client creation).

### AuthFailed

public static final Watcher.Event.KeeperState AuthFailed
Auth failed state

### ConnectedReadOnly

public static final Watcher.Event.KeeperState ConnectedReadOnly
The client is connected to a read-only server, that is the server which is not currently connected to the majority. The only operations allowed after receiving this state is read operations. This state is generated for read-only clients only since read/write clients aren't allowed to connect to r/o servers.

### SaslAuthenticated

public static final Watcher.Event.KeeperState SaslAuthenticated
SaslAuthenticated: used to notify clients that they are SASL-authenticated, so that they can perform Zookeeper actions with their SASL-authorized permissions.

### Expired

public static final Watcher.Event.KeeperState Expired
The serving cluster has expired this session. The ZooKeeper client connection (the session) is no longer valid. You must create a new client connection (instantiate a new ZooKeeper instance) if you with to access the ensemble.

### Closed

public static final Watcher.Event.KeeperState Closed
The client has been closed. This state is never generated by the server, but is generated locally when a client calls `ZooKeeper.close()` or `ZooKeeper.close(int)`

## Method Details

### values

public static Watcher.Event.KeeperState[] values()
Returns an array containing the constants of this enum type, in the order they are declared.

Returns:
  an array containing the constants of this enum type, in the order they are declared

### valueOf

public static Watcher.Event.KeeperState valueOf(String name)
Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null

### getIntValue

public int getIntValue()

### fromInt

public static Watcher.Event.KeeperState fromInt(int intValue)